var segments = [];

var pcSegments = ["Dining_and_Social", "Tennis", "MGA", "WGA", "Twelve_Thirty_Club"];

$(document).ready(function () {
    firebase.auth().onAuthStateChanged(function(user) {
        if (user) {
            $("#username-text").text("(" + firebase.auth().currentUser.providerData[0].email + ")");
        }
    });
  $("#tags").tagsinput({
    confirmKeys: [13, 44, 32, 188]
  }); 
  for (var i = 0; i < segments.length; i++){
    $("#tags").tagsinput('add', segments[i]);
  }

  for (var i = 0; i < pcSegments.length; i++){
    $('#checkbox').append('<input type="checkbox" name="segments" class="chk" value="' + pcSegments[i] + '" />' + "  " + pcSegments[i] + " <br>"); 
  }

  $(".chk").change(function() {
    var ops;
    if(this.checked) {
       ops = "add";
    } else { 
      ops = "remove";
    }

     $("#tags").tagsinput(ops, $(this).val());
     $("#tags").tagsinput(ops, "PC-" + $(this).val());
});

  // Scheduled date and time
  $('#datetime12').combodate({
          value: new Date(),
          format:"YYYY-MM-DDTHH:mm:ss",
          template:"DD / MM / YYYY     hh : mm a",
          firstItem: "none",
          roundTime:false,
          minuteStep:1,
          smartDays:true,
          minYear: moment().format("YYYY") ,
          maxYear: (parseInt(moment().format("YYYY")) + 1) 
    }); 

  $("#push-time").change(function(){
      $( "select option:selected").each(function(){
          if($(this).attr("value")=="now"){
              $("#scheduled-details").hide(); 
          }
          if($(this).attr("value")=="scheduled"){ 
              $("#scheduled-details").show();
          } 
      });
  }).change();

  // Time Zone
  var currentTimeZone = moment().format('Z');
  $("#time-zone").append('<option value="'+currentTimeZone+'">'+currentTimeZone+'</option>');
  $("#time-zone").append('<option value="">Local to User');

  // Character count   
  Countable.live(document.getElementById("push-content"), function (counter) { 
    $("#count").text(counter.all);
  })
});

function generateUUID(){
    var d = new Date().getTime();
    var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
        var r = (d + Math.random()*16)%16 | 0;
        d = Math.floor(d/16);
        return (c=='x' ? r : (r&0x3|0x8)).toString(16);
    });
    return uuid;
};

var campaignId;

function pushToClients(){

  campaignId = generateUUID();
  var iosStatusSelector = "#status-ios";
  var androidStatusSelector = "#status-android";

  // clear status
  $(iosStatusSelector).text( "");
  $(iosStatusSelector).removeAttr("class"); 
  $(androidStatusSelector).text( "");
  $(androidStatusSelector).removeAttr("class"); 

  var isIos = $('#ios-client').is(':checked');
  var isAndroid = $('#android-client').is(':checked');

  if(!isIos && !isAndroid){
    $(iosStatusSelector).attr("class","error"); 
    $(iosStatusSelector).text( "You need to select at least one Device Type");
  }

  if(isIos) { 
    $(iosStatusSelector).removeAttr("class"); 
    $(iosStatusSelector).text( "In progress...");
      console.log("sending iOS...");

      push('ios', iosStatusSelector);
  }

  if(isAndroid) { 
    $(androidStatusSelector).removeAttr("class"); 
    $(androidStatusSelector).text( "In progress...");
      console.log("sending Android...");

      push('android', androidStatusSelector);

  }
}

function push(platform, statusSelector) {
    console.log("inside push...");
    var i = 1;
    firebase.database().ref('users/' + firebase.auth().currentUser.uid).once('value', function (snapshot) {
        console.log("call number " + i + " with payload" + snapshot);
        i++;
        console.log(snapshot.val());

        // Get Data from UI
        var content = $("#push-content").val();
        var screenNickname = $("#nickname").val();
        var tags = $("#tags").tagsinput('items'); 
        for (var i = 0; i < tags.length; i++) {
            tags[i] = tags[i].toLowerCase();
        }
        var timeOption = {};
        if ($("#push-time option:selected").val() === "scheduled") {
            var timeStr = ($("#datetime12").combodate("getValue") + $("#time-zone option:selected").val());
            timeOption.time = moment(Date.parse(timeStr)).format("YYYY-MM-DDThh:mm:ss");
            ;
            timeOption.type = $("#time-zone option:selected").val() ? "global" : "local";
        } else {
            timeOption.time = "now";
            timeOption.type = "global";
        }

        // Create Payload
        var payload = {};
        payload.name = "Push Campaign Created at " + new Date();
        payload.live = true;
        payload.messages = [{language: "en", body: content}];
        if (timeOption.type == "global") {
            payload.push_time = timeOption.time
        } else {
            payload.local_push_time = timeOption.time;
        }
        payload.custom_payload = {};
        if (screenNickname) {
            payload.custom_payload.nickname = screenNickname;
        }
        if (tags && tags.length > 0) {
            payload.targeting = {
                "query": {
                    "t.channels": {
                        "$contains": tags
                    }
                }
            };
        }
        if (platform == "ios") {
            // options.data.sound = "default"
        }
        payload.custom_payload = JSON.stringify(payload.custom_payload); //.replace(/"/g, '\\"');
        console.log(payload);

        // Prepare to send
        var restApikey = snapshot.val().restApiKey;
        var apiKey = platform == "android" ? snapshot.val().androidApiKey : snapshot.val().iosApiKey;
        console.log("sending now...")
        sendRequest(apiKey, restApikey, payload, statusSelector, platform);

    });
}

function sendRequest(apiKey,restApiKey, payload, statusSelector, platform) {
    console.log("sending request...");
    // var payloadWithoutCustom = JSON.stringify(payload, replacer)
    // var replacer = function(key, value) { return key == "custom_payload" ? undefined : value; };
    console.log(JSON.stringify(payload));
    $.ajax({
        url: 'https://api.batch.com/1.0/' + apiKey + '/campaigns/create',
        type: 'post',
        data: JSON.stringify(payload),
        headers: {
            "X-Authorization": restApiKey
        },
        contentType: 'application/json',
        dataType: 'json',
        error: function(xhr, error){
            $(statusSelector).attr("class","error");
            $(statusSelector).text(  platform.toUpperCase() + " - " + "Error while sending notification:  " + JSON.parse(xhr.responseText).error);
        },
        success: function (data) {
            $(statusSelector).attr("class","success");
            $(statusSelector).text( platform.toUpperCase() + " - " + "Push sent successfuly");
            saveToArchive(payload, platform);
        }
    });
}

function saveToArchive(payload, platform){
    var segments;
    segments = payload.targeting ? payload.targeting["query"]["t.channels"]["$contains"] : "";
    var deliveryTime = payload.push_time ? payload.push_time : payload.local_push_time;
    deliveryTime = deliveryTime == "now" ? new Date().toString() : deliveryTime;
    firebase.database().ref('users/' + firebase.auth().currentUser.uid + "/history/" + campaignId).set({
        campignId: campaignId,
        fullData: JSON.stringify(payload),
        message: payload.messages[0].body,
        deviceType: platform,
        deliveryTime: deliveryTime,
        segments: segments
    }).then(
        function (result) {
           console.log("success", result);
    }, function (error) {
            console.log("error", error);
        });

}